﻿
using MasterDetailsViewDemo;
using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace ExcelLikeFiltering
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.DataContext = new ViewModel();
            
            this.dataGrid.FilterChanging += dataGrid_FilterChanging;
            this.dataGrid.FilterItemsPopulated += dataGrid_FilterItemsPopulated;
        }
        IEnumerable<FilterElement> filterItems;

       private void dataGrid_FilterChanging(object sender, Syncfusion.UI.Xaml.Grid.GridFilterEventArgs e)
        {
            if (e.FilterPredicates == null || filterItems == null || !e.FilterPredicates.Any() || !filterItems.Any())
                return;

            e.FilterPredicates.Clear();
            var selectedItems = filterItems.Where(x => x.IsSelected);
            int i = 0;
            foreach (var item in selectedItems)
            {
                if (i == 0)
                    e.FilterPredicates.Add(new FilterPredicate()
                        {
                            FilterValue = item.ActualValue,
                            FilterType = FilterType.Equals,
                            FilterBehavior = FilterBehavior.StronglyTyped,
                            IsCaseSensitive = true,
                            PredicateType = PredicateType.And
                        });
                else
                {
                    e.FilterPredicates.Add(new FilterPredicate()
                        {
                            FilterValue = item.ActualValue,
                            FilterType = FilterType.Equals,
                            FilterBehavior = FilterBehavior.StronglyTyped,
                            IsCaseSensitive = true,
                            PredicateType = PredicateType.Or
                        });

                }
                i++;
            }
        }

        private void dataGrid_FilterItemsPopulated(object sender,
                                                   Syncfusion.UI.Xaml.Grid.GridFilterItemsPopulatedEventArgs e)
        {
            filterItems = e.ItemsSource as IEnumerable<FilterElement>;
            e.FilterControl.FilterMode = FilterMode.CheckboxFilter;
        }
    

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }
    }
}
